<?php

declare(strict_types=1);

namespace Dedi\SyliusStockHistoryPlugin\Enum;

/**
 * We use enum cases that depend on constants to be able to use those constants in the grid filter for the admin (see config/grids/inventory_log_entry.yaml)
 * With Symfony 6.2 support for !php/enum in yaml config, those const will be removed
 */
enum InventoryLogEntryType: string
{
    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::DEFAULT->value instead
     */
    public const TYPE_DEFAULT = 'default';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::SHOP_CHECKOUT_COMPLETE->value instead
     */
    public const TYPE_SHOP_CHECKOUT_COMPLETE = 'shop_checkout_complete';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::SHOP_PAYMENT_COMPLETE->value instead
     */
    public const TYPE_SHOP_PAYMENT_COMPLETE = 'shop_payment_complete';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::ADMIN_VARIANT_EDIT->value instead
     */
    public const TYPE_ADMIN_VARIANT_EDIT = 'admin_variant_edit';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::ADMIN_ORDER_CANCELED->value instead
     */
    public const TYPE_ADMIN_ORDER_CANCELED = 'admin_order_canceled';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::ADMIN_PAYMENT_COMPLETE->value instead
     */
    public const TYPE_ADMIN_PAYMENT_COMPLETE = 'admin_payment_complete';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::API_VARIANT_EDIT->value instead
     */
    public const TYPE_API_VARIANT_EDIT = 'api_variant_edit';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::API_ORDER_COMPLETE->value instead
     */
    public const TYPE_API_ORDER_COMPLETE = 'api_order_complete';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::API_ORDER_CANCEL->value instead
     */
    public const TYPE_API_ORDER_CANCEL = 'api_order_cancel';

    /**
     * @deprecated use Dedi\SyliusStockHistoryPlugin\Enum\InventoryLogEntryType::API_PAYMENT_COMPLETE->value instead
     */
    public const TYPE_API_PAYMENT_COMPLETE = 'api_payment_complete';

    case DEFAULT = self::TYPE_DEFAULT;
    case SHOP_CHECKOUT_COMPLETE = self::TYPE_SHOP_CHECKOUT_COMPLETE;
    case SHOP_PAYMENT_COMPLETE = self::TYPE_SHOP_PAYMENT_COMPLETE;
    case ADMIN_VARIANT_EDIT = self::TYPE_ADMIN_VARIANT_EDIT;
    case ADMIN_ORDER_CANCELED = self::TYPE_ADMIN_ORDER_CANCELED;
    case ADMIN_PAYMENT_COMPLETE = self::TYPE_ADMIN_PAYMENT_COMPLETE;
    case API_VARIANT_EDIT = self::TYPE_API_VARIANT_EDIT;
    case API_ORDER_COMPLETE = self::TYPE_API_ORDER_COMPLETE;
    case API_ORDER_CANCEL = self::TYPE_API_ORDER_CANCEL;
    case API_PAYMENT_COMPLETE = self::TYPE_API_PAYMENT_COMPLETE;
}
