<?php

declare(strict_types=1);

namespace Dedi\SyliusStockHistoryPlugin\EventListener\Admin;

use Dedi\Contracts\SyliusPluginSettings\SettingsProviderInterface;
use Dedi\SyliusStockHistoryPlugin\DependencyInjection\Settings\SettingsInterface;
use Knp\Menu\ItemInterface;
use Sylius\Bundle\UiBundle\Menu\Event\MenuBuilderEvent;

class InventoryLogMenuBuilder
{
    public function __construct(private readonly SettingsProviderInterface $settingsProvider)
    {
    }

    public function addItem(MenuBuilderEvent $event): void
    {
        /** @var SettingsInterface $settings */
        $settings = $this->settingsProvider->provide();

        if (!$settings->isEnabled() || !$settings->isAdminEnabled()) {
            return;
        }

        $menu = $event->getMenu()->getChild('catalog');

        if ($menu instanceof ItemInterface) {
            $menu
                ->addChild('stock_history', ['route' => 'dedi_sylius_stock_history_plugin_admin_inventory_log_entry_index'])
                ->setLabel('dedi_sylius_stock_history_plugin.ui.inventory_log')
                ->setLabelAttribute('icon', 'exchange')
            ;
        }
    }
}
