<?php

declare(strict_types=1);

namespace Dedi\SyliusStockHistoryPlugin\Factory;

use Dedi\SyliusStockHistoryPlugin\Entity\InventoryLogEntryInterface;
use Sylius\Component\Core\Model\OrderInterface;
use Sylius\Component\Core\Model\ProductVariantInterface;
use Sylius\Component\Resource\Factory\FactoryInterface;

interface InventoryLogEntryFactoryInterface extends FactoryInterface
{
    public function create(
        ProductVariantInterface $variant,
        string $type,
        int $onHand,
        int $onHold,
        ?int $previousOnHand,
        ?int $previousOnHold,
        string $path,
        ?OrderInterface $order = null,
    ): InventoryLogEntryInterface;
}
