<?php

declare(strict_types=1);

namespace Dedi\SyliusStockHistoryPlugin\Repository;

use DateTimeInterface;
use Doctrine\ORM\QueryBuilder;
use Sylius\Bundle\ResourceBundle\Doctrine\ORM\EntityRepository;

class InventoryLogEntryRepository extends EntityRepository implements InventoryLogEntryRepositoryInterface
{
    public function createListQueryBuilder(): QueryBuilder
    {
        return $this->createQueryBuilder('o')
        ;
    }

    public function findOlderThan(DateTimeInterface $date, ?int $limit = null): array
    {
        $qb = $this->createQueryBuilder('o')
            ->andWhere('o.loggedAt < :date')
            ->setParameter('date', $date)
        ;

        if (null !== $limit) {
            $qb->setMaxResults($limit);
        }

        return $qb->getQuery()->getResult();
    }
}
